#include <Arduino.h>
#include <BlockNot.h>


#define SEND_SERIAL sendSerial
#define PROCESS_SERIAL processSerial()
bool blink = true;

BlockNot pingTimer(5, SECONDS);
BlockNot blinkTimer(500);

void sendSerial(const String& message) {
    Serial.println(message);
}

void processSerial() {
    if(Serial.available()) {
        String serialData = Serial.readString();
    if(serialData.startsWith("blink")) {
            blink = !blink;
            SEND_SERIAL(blink ? "Blink Enabled" : "Blink Disabled");
        }
    }
}

void setup() {
    Serial.begin(57600);
    pinMode(LED_BUILTIN, OUTPUT);
    delay(8000);
    SEND_SERIAL("Arduino Ready!");
}

void loop() {
    static bool state = false;
    PROCESS_SERIAL;
    if(pingTimer.TRIGGERED) {
        SEND_SERIAL("pingnano");
    }
    if(blink && blinkTimer.TRIGGERED) {
        digitalWrite(LED_BUILTIN, state);
        state = !state;
    }
    if (!blink) {
        digitalWrite(LED_BUILTIN, LOW);
    }
}